/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2022/08/08
 * Description        : Main program body.
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * SPDX-License-Identifier: Apache-2.0
 *******************************************************************************/

#include <SPI_FLASH.h>
#include <SW_UDISK.h>
#include "debug.h"
#include "usb_lib.h"
#include "Internal_Flash.h"
#include "ff.h"

/* @Note
 * UDisk Example:
 * This program provides examples of UDisk.Supports external SPI Flash and internal
 * Flash, selected by STORAGE_MEDIUM at SW_UDISK.h.
 *  */
FATFS fs; /* FatFsļϵͳ */
FIL fnew;   /* ļ */
FRESULT res_flash;  /* ļ */
UINT fnum;    /* ļɹд */
BYTE ReadBuffer[512]={0};/*  */
BYTE WriteBuffer[] =  /* д*/
"This is a CH32V203_W25Q16_SPI_FLASH_FATFS_SYSTEM experiment\r\n";

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */

int main(void)
{
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    Delay_Init();
    USART_Printf_Init(115200);
    printf("SystemClk:%d\r\n",SystemCoreClock);


#if (STORAGE_MEDIUM == MEDIUM_SPI_FLASH)
    printf("USBD UDisk Demo - Storage Medium: SPI FLASH \r\n");
    /* SPI flash init */
    FLASH_Port_Init( );
    /* FLASH ID check */
    FLASH_IC_Check( );
#elif (STORAGE_MEDIUM == MEDIUM_INTERAL_FLASH)
    printf("USBD UDisk Demo - Storage Medium: INTERNAL FLASH \r\n");
    Flash_Sector_Count = IFLASH_UDISK_SIZE  / DEF_UDISK_SECTOR_SIZE;
    Flash_Sector_Size = DEF_UDISK_SECTOR_SIZE;
#endif


    Delay_Ms(10);
        char filename[20];



        res_flash = f_mount( &fs, "1:", 1 );                    // ļϵͳ 0

        if( res_flash == FR_NO_FILESYSTEM )                     // ûļϵͳ
        {
            printf("δļϵͳʼʽ: ");

            res_flash=f_mkfs( "1:", 0, 0 );    // ʽ ļϵͳ
            if( res_flash == FR_OK )
            {
                printf("ʽɹ\r\n");
                res_flash = f_mount( NULL, "1:", 1 );           // ʽȡ
                res_flash = f_mount( &fs,  "1:", 1 );           // ¹
            }
            else
            {
                printf("ʽʧ\r\n");
                                                      // ʧ
            }
        }
        else if( res_flash == FR_OK )                           // سɹ
        {
            printf("Ŀ¼: ");

            strcpy( filename, "1:/TestDir" );
            res_flash = f_mkdir( filename );
            printf("res_flash=%X\r\n",res_flash);
            if( res_flash == FR_OK )
            {
                printf("ɹļ[%s]\r\n", filename );
            }
            else if( res_flash == FR_EXIST )
            {
                printf("ļѴ\r\n");
            }
            else
            {
                printf("ļдʧ: %d\r\n", res_flash );
            }

            printf("ļд빦: ");

            res_flash = f_open( &fnew, "1:TestDir/TestFile.txt", FA_CREATE_ALWAYS | FA_WRITE );             // д뷽ʽļδļ½ļ
            printf("res_flash=%X\r\n",res_flash);
            if( res_flash == FR_OK )
            {
                res_flash = f_write( &fnew, WriteBuffer, strlen(WriteBuffer), &fnum );                      // дļдָ
                if( res_flash == FR_OK )
                {
                    printf("ɹд[%d]ֽ:[%s]\r\n", fnum, WriteBuffer );
                    f_close(&fnew);                                                                         // رļ

                    printf("ļȡ: ");
                    res_flash = f_open(&fnew, "1:TestDir/TestFile.txt", FA_OPEN_EXISTING | FA_READ );       // ´
                    if( res_flash == FR_OK )
                    {
                        res_flash = f_read(&fnew, ReadBuffer, sizeof(ReadBuffer), &fnum);
                        if(res_flash==FR_OK)
                        {
                            printf("ɹȡ[%d]ֽ:[%s]\r\n", fnum, ReadBuffer );
                        }
                        else
                        {
                            printf("ļȡʧ: %d\r\n", res_flash );

                        }
                    }
                    else
                    {
                        printf("ļʧ\r\n");

                    }
                    f_close(&fnew);
                }
                else
                {
                    printf("ļдʧ: %d\r\n",res_flash);
                    f_close(&fnew);                                                                     // رļ
                                                                                               // ʧ
                }
            }
            else
            {
                printf("ļ򿪻ߴʧ\r\n");
                                                                                               // ʧ
            }

        }
        else
        {
            printf("ļϵͳʧ: %d\r\n", res_flash );
            printf(" SPI Flash ״̬\r\n");
                                                                                               // ʧ
        }

        f_mount( NULL, "1:", 1 );                                                                       // жļϵͳ


    /* Enable Udisk */
     Udisk_Capability = Flash_Sector_Count;
     Udisk_Status |= DEF_UDISK_EN_FLAG;
     /* USBD init */
     Set_USBConfig();
     USB_Init();
     USB_Interrupts_Config();



    while(1)
    {
        ;
    }
}









